<sqtm-core-entity-view-wrapper [sqtmCoreViewId]="'test-case-view'">
  @if (componentData$ | async; as componentData) {
    <div class="flex full-height full-width neutral-background-color">
      <div class="flex-column full-width">
        <sqtm-core-entity-view-header
          class="full-width content-head p-t-10 p-r-20"
          [attachmentList]="componentData.testCase.attachmentList"
          [entityPath]="componentData.testCase.path"
          (attachmentBadgeClickEvent)="toggleAttachmentPanel()"
        >
          <div projection="actions" class="m-t-6" style="width: 40px">
            <ng-content
              #projectedButtons
              select="[projection=detail-buttons]"
            ></ng-content>

            @if (showFoldAndCloseButtons) {
              <div class="flex-column m-t-10" style="width: 40px">
                <sqtm-core-close-button class="m-b-20"></sqtm-core-close-button>
                <sqtm-core-fold-button></sqtm-core-fold-button>
              </div>
            }

            @if (showFoldButtonOnly) {
              <div class="m-t-10">
                <sqtm-core-fold-button></sqtm-core-fold-button>
              </div>
            }
          </div>
          <div projection="reference" class="reference">
            <sqtm-core-editable-text-field
              [attr.data-test-field-id]="'entity-reference'"
              [sqtmCoreEntityViewEditableTextField]="'reference'"
              ngDefaultControl
              [layout]="'compact'"
              placeholder="{{
                'sqtm-core.test-case-workspace.reference.placeholder'
                  | translate
              }}"
              [trimValue]="true"
            >
            </sqtm-core-editable-text-field>
          </div>
          <div
            projection="notifications"
            class="m-r-40"
            [attr.data-test-element-id]="'notifications'"
          >
            @if (!componentData.milestonesAllowModification) {
              <div
                [attr.data-test-element-id]="'milestone-locked-warning'"
                nz-tooltip
                [nzTooltipTitle]="lockedMilestoneMessage"
                [nzTooltipPlacement]="'bottom'"
                class="font-20-px sqtm-core-error-message"
              >
                <i
                  nz-icon
                  nzType="sqtm-core-nav:milestone"
                  nzTheme="outline"
                ></i>
              </div>
            }
          </div>
          @if (
            isMilestoneModeEnabled() || componentData.permissions.canExport
          ) {
            <div
              projection="menu"
              [attr.data-test-toolbar-button-id]="'action-menu-button'"
            >
              <span
                class="font-20-px"
                nz-dropdown
                [nzDropdownMenu]="actionMenu"
                [nzPlacement]="'bottomCenter'"
              >
                <i
                  nz-icon
                  nzType="sqtm-core-generic:more"
                  nzTheme="outline"
                  class="current-workspace-button"
                ></i>
              </span>
            </div>
          }
          <div projection="capsule" class="sqtm-core-capsules-container">
            <sqtm-core-capsule-information
              [informationData]="
                getStatusInformationData(componentData.testCase.status)
              "
              [editable]="
                componentData.permissions.canWrite &&
                componentData.milestonesAllowModification
              "
              [listPanelItems]="this.statusItems"
              [selectedItem]="componentData.testCase.status"
              [attr.data-test-capsule-id]="'status'"
              (itemSelectionChanged)="updateTestCaseStatus($event)"
            >
            </sqtm-core-capsule-information>
            <sqtm-core-capsule-information
              [informationData]="
                getImportanceInformationData(componentData.testCase.importance)
              "
              [editable]="
                !componentData.testCase.importanceAuto &&
                componentData.permissions.canWrite &&
                componentData.milestonesAllowModification
              "
              [listPanelItems]="this.importanceItems"
              [selectedItem]="componentData.testCase.importance"
              [attr.data-test-capsule-id]="'importance'"
              (itemSelectionChanged)="updateTestCaseImportance($event)"
            >
            </sqtm-core-capsule-information>
            <sqtm-core-capsule-test-case-last-execution-status
              [informationData]="
                getLastExecutionInformationData(
                  componentData.testCase.lastExecutionStatus
                )
              "
            >
            </sqtm-core-capsule-test-case-last-execution-status>
            @if (componentData.testCase.draftedByAi) {
              <sqtm-core-capsule-information
                [informationData]="getDraftedByAiInformationData()"
                [attr.data-test-capsule-id]="'drafted-by-ai'"
              >
              </sqtm-core-capsule-information>
            }
          </div>
        </sqtm-core-entity-view-header>
        <div class="flex-row full-height full-width">
          <div class="flex-fixed-size side-bar">
            <div class="anchor-bar">
              <sqtm-core-anchor>
                <sqtm-core-anchor-group [id]="'content'">
                  <sqtm-core-anchor-link
                    nz-tooltip
                    nzTooltipPlacement="right"
                    sqtmCoreDefaultAnchorLink
                    [id]="'information'"
                    [nzTooltipTitle]="
                      'sqtm-core.test-case-workspace.title.information'
                        | translate
                    "
                    [iconName]="'sqtm-core-test-case:informations'"
                  >
                  </sqtm-core-anchor-link>
                  @if (!isExploratory(componentData.testCase.kind)) {
                    <sqtm-core-anchor-link
                      [id]="'automation'"
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [nzTooltipTitle]="
                        'sqtm-core.test-case-workspace.title.automation'
                          | translate
                      "
                      [iconName]="'sqtm-core-test-case:automation'"
                    >
                    </sqtm-core-anchor-link>
                  }
                  <sqtm-core-anchor-link
                    [id]="'verified-requirements'"
                    nz-tooltip
                    nzTooltipPlacement="right"
                    [nzTooltipTitle]="
                      'sqtm-core.test-case-workspace.title.coverages'
                        | translate
                    "
                    [iconName]="'sqtm-core-test-case:coverages'"
                  >
                    @if (
                      testCaseViewService.coveragesCount$ | async;
                      as coverageCount
                    ) {
                      @if (coverageCount > 0) {
                        <div class="anchor-counter">
                          <span>{{ coverageCount }}</span>
                        </div>
                      }
                    }
                  </sqtm-core-anchor-link>
                  @if (
                    !isGherkin(componentData.testCase.kind) &&
                    !isExploratory(componentData.testCase.kind)
                  ) {
                    <sqtm-core-anchor-link
                      [id]="'parameters'"
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [nzTooltipTitle]="
                        'sqtm-core.test-case-workspace.title.parameters'
                          | translate
                      "
                      [iconName]="'sqtm-core-test-case:param_and_dataset'"
                    >
                      @if (
                        testCaseViewService.datasetCount$ | async;
                        as datasetCount
                      ) {
                        @if (datasetCount > 0) {
                          <div class="anchor-counter">
                            <span>{{ datasetCount }}</span>
                          </div>
                        }
                      }
                    </sqtm-core-anchor-link>
                  }
                  @if (isStandard(componentData.testCase.kind)) {
                    <sqtm-core-anchor-link
                      [id]="'called-test-cases'"
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [nzTooltipTitle]="
                        'sqtm-core.test-case-workspace.title.called-steps'
                          | translate
                      "
                      [iconName]="'sqtm-core-test-case:called_test_case'"
                    >
                    </sqtm-core-anchor-link>
                  }
                </sqtm-core-anchor-group>

                <sqtm-core-anchor-group [id]="'charter'">
                  <sqtm-core-anchor-link
                    [visible]="isExploratory(componentData.testCase.kind)"
                    [id]="'charter'"
                    nz-tooltip
                    nzTooltipPlacement="right"
                    [nzTooltipTitle]="
                      'sqtm-core.test-case-workspace.title.charter' | translate
                    "
                    [iconName]="'sqtm-core-test-case:charter'"
                  >
                  </sqtm-core-anchor-link>
                </sqtm-core-anchor-group>

                @switch (componentData.testCase.kind) {
                  @case ('STANDARD') {
                    <sqtm-core-anchor-group [id]="'steps'">
                      <sqtm-core-anchor-link
                        [id]="'steps'"
                        nz-tooltip
                        nzTooltipPlacement="right"
                        [nzTooltipTitle]="
                          'sqtm-core.test-case-workspace.title.prerequisite-and-test-steps'
                            | translate
                        "
                        [iconName]="'sqtm-core-test-case:test_step'"
                      >
                        @if (
                          testCaseViewService.stepCount$ | async;
                          as stepCount
                        ) {
                          @if (stepCount > 0) {
                            <div class="anchor-counter">
                              <span>{{ stepCount }}</span>
                            </div>
                          }
                        }
                      </sqtm-core-anchor-link>
                    </sqtm-core-anchor-group>
                  }

                  @case ('GHERKIN') {
                    <sqtm-core-anchor-group [id]="'script'">
                      <sqtm-core-anchor-link
                        [id]="'script'"
                        nz-tooltip
                        nzTooltipPlacement="right"
                        [nzTooltipTitle]="
                          'sqtm-core.test-case-workspace.title.script'
                            | translate
                        "
                        [iconName]="'sqtm-core-test-case:script'"
                      >
                      </sqtm-core-anchor-link>
                    </sqtm-core-anchor-group>
                  }

                  @case ('KEYWORD') {
                    <sqtm-core-anchor-group [id]="'keywordSteps'">
                      <sqtm-core-anchor-link
                        [id]="'keywordSteps'"
                        nz-tooltip
                        nzTooltipPlacement="right"
                        [nzTooltipTitle]="
                          'sqtm-core.test-case-workspace.title.test-steps'
                            | translate
                        "
                        [iconName]="'unordered-list'"
                      >
                        @if (
                          testCaseViewService.stepCount$ | async;
                          as stepCount
                        ) {
                          @if (stepCount > 0) {
                            <div class="anchor-counter">
                              <span>{{ stepCount }}</span>
                            </div>
                          }
                        }
                      </sqtm-core-anchor-link>
                    </sqtm-core-anchor-group>
                  }
                }
                @if (!isExploratory(componentData.testCase.kind)) {
                  <sqtm-core-anchor-group [id]="'executions'">
                    <sqtm-core-anchor-link
                      [id]="'executions'"
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [nzTooltipTitle]="
                        'sqtm-core.test-case-workspace.title.executions'
                          | translate
                      "
                      [iconName]="'sqtm-core-test-case:executions'"
                    >
                      @if (componentData.testCase.nbExecutions > 0) {
                        <div class="anchor-counter">
                          <span>{{ componentData.testCase.nbExecutions }}</span>
                        </div>
                      }
                    </sqtm-core-anchor-link>
                  </sqtm-core-anchor-group>
                } @else {
                  <sqtm-core-anchor-group [id]="'sessions'">
                    <sqtm-core-anchor-link
                      [id]="'sessions'"
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [nzTooltipTitle]="
                        'sqtm-core.test-case-workspace.title.sessions'
                          | translate
                      "
                      [iconName]="'sqtm-core-test-case:executions'"
                    >
                      @if (componentData.testCase.nbSessions > 0) {
                        <div class="anchor-counter">
                          <span>{{ componentData.testCase.nbSessions }}</span>
                        </div>
                      }
                    </sqtm-core-anchor-link>
                  </sqtm-core-anchor-group>
                }

                @if (componentData.projectData.bugTracker) {
                  <sqtm-core-anchor-group [id]="'issues'">
                    <sqtm-core-anchor-link
                      [id]="'issues'"
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [nzTooltipTitle]="
                        'sqtm-core.test-case-workspace.title.issues' | translate
                      "
                      [iconName]="'sqtm-core-generic:issues'"
                    >
                      @if (componentData.testCase.nbIssues > 0) {
                        <div class="anchor-counter">
                          <span>{{ componentData.testCase.nbIssues }}</span>
                        </div>
                      }
                    </sqtm-core-anchor-link>
                  </sqtm-core-anchor-group>
                }
              </sqtm-core-anchor>
            </div>
          </div>
          <div #content class="test-case-content-body full-height full-width">
            <router-outlet></router-outlet>
          </div>
        </div>
      </div>
    </div>
    <sqtm-core-attachment-drawer
      [canAttach]="
        componentData.permissions.canAttach &&
        componentData.milestonesAllowModification
      "
    >
    </sqtm-core-attachment-drawer>
    <sqtm-core-drawer
      [localTheme]="requirementWorkspace"
      [isVisible]="componentData.testCase.uiState.openRequirementTreePicker"
      [titleKey]="'sqtm-core.tree-picker.requirement.title'"
      (close)="closeRequirementPicker()"
    >
      <i
        projection="icons"
        nz-icon
        nzType="sqtm-core-generic:help"
        nzTheme="fill"
        class="m-l-10 font-20-px current-workspace-main-color"
        nz-tooltip
        [nzTooltipTitle]="
          'sqtm-core.tree-picker.requirement.test-case-coverages' | translate
        "
      ></i>
      @if (componentData.testCase.uiState.openRequirementTreePicker) {
        <sqtm-core-requirement-picker
          [pickerPersistenceKey]="'bind-requirement-to-test-case'"
        >
        </sqtm-core-requirement-picker>
      }
    </sqtm-core-drawer>
    <sqtm-core-drawer
      [localTheme]="testCaseWorkspace"
      [titleKey]="'sqtm-core.tree-picker.test-case.title'"
      [isVisible]="componentData.testCase.uiState.openTestCaseTreePicker"
      (close)="closeTestCasePickerDrawer()"
    >
      <i
        projection="icons"
        nz-icon
        nzType="sqtm-core-generic:help"
        nzTheme="fill"
        class="m-l-10 font-20-px current-workspace-main-color"
        nz-tooltip
        [nzTooltipTitle]="
          'sqtm-core.tree-picker.test-case.test-case-call' | translate
        "
      ></i>
      @if (componentData.testCase.uiState.openTestCaseTreePicker) {
        <sqtm-core-test-case-picker [pickerPersistenceKey]="'call-test-case'">
        </sqtm-core-test-case-picker>
      }
    </sqtm-core-drawer>
    <nz-dropdown-menu #actionMenu="nzDropdownMenu">
      @if (
        this.referentialDataService.milestoneModeData$ | async;
        as milestoneState
      ) {
        <ul nz-menu [attr.data-test-menu-id]="'action-menu'">
          @if (isMilestoneModeEnabled()) {
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="'create-test-case-version'"
              [nzDisabled]="
                milestoneState.selectedMilestone.status === 'LOCKED'
              "
              (click)="createNewTestCaseVersion()"
            >
              {{ 'sqtm-core.generic.label.add-new-version' | translate }}
            </li>
          }
          @if (componentData.permissions.canExport) {
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="'open-in-print-mode'"
              (click)="openInPrintMode(componentData)"
            >
              {{ 'sqtm-core.generic.label.print' | translate }}
            </li>
          }
        </ul>
      }
    </nz-dropdown-menu>
  }
</sqtm-core-entity-view-wrapper>

<ng-template #lockedMilestoneMessage>
  {{ 'sqtm-core.entity.generic.milestone.locked' | translate }}
</ng-template>
